<?php

	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
	
	// Check Array Input
	PHPCUS_PARAM::CUS_DOES_NOT_SUPPORT_ARRAY();
	
	// Check already authenticated
	PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();
	// Check access rights
	PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_ONLY, 'record_eod_payrep');
	
	if
	(
		PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
		(
			[
					'PARAM_REC_EODPAY_ID',
					'PARAM_REC_EODPAY_REC_EODREP_ID',
					'PARAM_REC_EODPAY_TRANSACTION_FROM',
					'PARAM_REC_EODPAY_TRANSACTION_TO',
					'PARAM_REC_EODPAY_PAID_CASH_FROM',
					'PARAM_REC_EODPAY_PAID_CASH_TO',
					'PARAM_REC_EODPAY_PAID_CARD_FROM',
					'PARAM_REC_EODPAY_PAID_CARD_TO',
					'PARAM_REC_EODPAY_PAID_CHECK_FROM',
					'PARAM_REC_EODPAY_PAID_CHECK_TO',
					'PARAM_REC_EODPAY_PAID_BANK_FROM',
					'PARAM_REC_EODPAY_PAID_BANK_TO',
					'PARAM_REC_EODPAY_PAID_LOYALTY_FROM',
					'PARAM_REC_EODPAY_PAID_LOYALTY_TO',
					'PARAM_REC_EODPAY_PAID_VOUCHER_FROM',
					'PARAM_REC_EODPAY_PAID_VOUCHER_TO',
					'PARAM_REC_EODPAY_PAID_OTHER_FROM',
					'PARAM_REC_EODPAY_PAID_OTHER_TO',
					'PARAM_REC_EODPAY_STATUS',
					
					'PARAM_ORDER_FIELD',
					'PARAM_ORDER_TYPE',
					'PARAM_SKIP',
					'PARAM_LIMIT'
			], True
		)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------	
			$PARAM_REC_EODPAY_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_EODPAY_ID');
			$PARAM_REC_EODPAY_REC_EODREP_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_EODPAY_REC_EODREP_ID');
			$PARAM_REC_EODPAY_TRANSACTION_FROM = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_EODPAY_TRANSACTION_FROM');
			$PARAM_REC_EODPAY_TRANSACTION_TO = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_EODPAY_TRANSACTION_TO');
			$PARAM_REC_EODPAY_PAID_CASH_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAY_PAID_CASH_FROM');
			$PARAM_REC_EODPAY_PAID_CASH_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAY_PAID_CASH_TO');
			$PARAM_REC_EODPAY_PAID_CARD_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAY_PAID_CARD_FROM');
			$PARAM_REC_EODPAY_PAID_CARD_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAY_PAID_CARD_TO');
			$PARAM_REC_EODPAY_PAID_CHECK_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAY_PAID_CHECK_FROM');
			$PARAM_REC_EODPAY_PAID_CHECK_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAY_PAID_CHECK_TO');
			$PARAM_REC_EODPAY_PAID_BANK_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAY_PAID_BANK_FROM');
			$PARAM_REC_EODPAY_PAID_BANK_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAY_PAID_BANK_TO');
			$PARAM_REC_EODPAY_PAID_LOYALTY_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAY_PAID_LOYALTY_FROM');
			$PARAM_REC_EODPAY_PAID_LOYALTY_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAY_PAID_LOYALTY_TO');
			$PARAM_REC_EODPAY_PAID_VOUCHER_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAY_PAID_VOUCHER_FROM');
			$PARAM_REC_EODPAY_PAID_VOUCHER_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAY_PAID_VOUCHER_TO');
			$PARAM_REC_EODPAY_PAID_OTHER_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAY_PAID_OTHER_FROM');
			$PARAM_REC_EODPAY_PAID_OTHER_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAY_PAID_OTHER_TO');
			$PARAM_REC_EODPAY_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_REC_EODPAY_STATUS');
			
			$PARAM_ORDER_FIELD = PHPCUS_PARAM::CUS_READ_SORT_FIELD
			(
					'PARAM_ORDER_FIELD',
					[
						'REC_EODPAY_ID', 
						'REC_EODPAY_REC_EODREP_ID', 
						'REC_EODPAY_TRANSACTION', 
						'REC_EODPAY_PAID_CASH', 
						'REC_EODPAY_PAID_CARD', 
						'REC_EODPAY_PAID_CHECK', 
						'REC_EODPAY_PAID_BANK', 
						'REC_EODPAY_PAID_LOYALTY', 
						'REC_EODPAY_PAID_VOUCHER', 
						'REC_EODPAY_PAID_OTHER', 
						'REC_EODPAY_STATUS'
						, 
						'REC_EODREP_ID',		
						'REC_EODREP_ACC_GROUP_ID',		
						'REC_EODREP_REC_POSDEVICE_ID',		
						'REC_EODREP_ACC_ACCOUNT_ID',		
						'REC_EODREP_TIME_CLOSED',		
						'REC_EODREP_SALE_TRANSACTION',		
						'REC_EODREP_SALE_SUBTOTAL',		
						'REC_EODREP_SALE_DISCOUNT',		
						'REC_EODREP_SALE_VATABLE',		
						'REC_EODREP_SALE_VATEXEMPT',		
						'REC_EODREP_SALE_NONVAT',		
						'REC_EODREP_SALE_ZERORATED',		
						'REC_EODREP_SALE_VAT',		
						'REC_EODREP_SALE_VAT_LESS',		
						'REC_EODREP_SALE_POINT',		
						'REC_EODREP_STATUS'		
					]
			);		
			$PARAM_ORDER_TYPE = PHPCUS_PARAM::CUS_READ_SORT_TYPE('PARAM_ORDER_TYPE');
			$PARAM_SKIP	= PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_SKIP');
			$PARAM_LIMIT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_LIMIT');
			
			// ------------------------------------------------------------------
			
			
			// Populate Map Array
			// ...........................................
			$GET_MAP_ARRAY = PHPCUS_RECORD_EOD_PAYREP::CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			
			$GET_MAP_ARRAY['PARAM_REC_EODPAY_ID'] = $PARAM_REC_EODPAY_ID;
			$GET_MAP_ARRAY['PARAM_REC_EODPAY_REC_EODREP_ID'] = $PARAM_REC_EODPAY_REC_EODREP_ID;
			$GET_MAP_ARRAY['PARAM_REC_EODPAY_TRANSACTION_FROM'] = $PARAM_REC_EODPAY_TRANSACTION_FROM;
			$GET_MAP_ARRAY['PARAM_REC_EODPAY_TRANSACTION_TO'] = $PARAM_REC_EODPAY_TRANSACTION_TO;
			$GET_MAP_ARRAY['PARAM_REC_EODPAY_PAID_CASH_FROM'] = $PARAM_REC_EODPAY_PAID_CASH_FROM;
			$GET_MAP_ARRAY['PARAM_REC_EODPAY_PAID_CASH_TO'] = $PARAM_REC_EODPAY_PAID_CASH_TO;
			$GET_MAP_ARRAY['PARAM_REC_EODPAY_PAID_CARD_FROM'] = $PARAM_REC_EODPAY_PAID_CARD_FROM;
			$GET_MAP_ARRAY['PARAM_REC_EODPAY_PAID_CARD_TO'] = $PARAM_REC_EODPAY_PAID_CARD_TO;
			$GET_MAP_ARRAY['PARAM_REC_EODPAY_PAID_CHECK_FROM'] = $PARAM_REC_EODPAY_PAID_CHECK_FROM;
			$GET_MAP_ARRAY['PARAM_REC_EODPAY_PAID_CHECK_TO'] = $PARAM_REC_EODPAY_PAID_CHECK_TO;
			$GET_MAP_ARRAY['PARAM_REC_EODPAY_PAID_BANK_FROM'] = $PARAM_REC_EODPAY_PAID_BANK_FROM;
			$GET_MAP_ARRAY['PARAM_REC_EODPAY_PAID_BANK_TO'] = $PARAM_REC_EODPAY_PAID_BANK_TO;
			$GET_MAP_ARRAY['PARAM_REC_EODPAY_PAID_LOYALTY_FROM'] = $PARAM_REC_EODPAY_PAID_LOYALTY_FROM;
			$GET_MAP_ARRAY['PARAM_REC_EODPAY_PAID_LOYALTY_TO'] = $PARAM_REC_EODPAY_PAID_LOYALTY_TO;
			$GET_MAP_ARRAY['PARAM_REC_EODPAY_PAID_VOUCHER_FROM'] = $PARAM_REC_EODPAY_PAID_VOUCHER_FROM;
			$GET_MAP_ARRAY['PARAM_REC_EODPAY_PAID_VOUCHER_TO'] = $PARAM_REC_EODPAY_PAID_VOUCHER_TO;
			$GET_MAP_ARRAY['PARAM_REC_EODPAY_PAID_OTHER_FROM'] = $PARAM_REC_EODPAY_PAID_OTHER_FROM;
			$GET_MAP_ARRAY['PARAM_REC_EODPAY_PAID_OTHER_TO'] = $PARAM_REC_EODPAY_PAID_OTHER_TO;
			$GET_MAP_ARRAY['PARAM_REC_EODPAY_STATUS'] = $PARAM_REC_EODPAY_STATUS;
			
			$GET_MAP_ARRAY["PARAM_ORDER_FIELD"] = $PARAM_ORDER_FIELD;
			$GET_MAP_ARRAY["PARAM_ORDER_TYPE"] = $PARAM_ORDER_TYPE;
			$GET_MAP_ARRAY["PARAM_SKIP"] = $PARAM_SKIP;
			$GET_MAP_ARRAY["PARAM_LIMIT"] = $PARAM_LIMIT;
			
			
			// Execute Stored Procedure
			// ...........................................
			$DATA_SET = PHPCUS_RECORD_EOD_PAYREP::CUS_GET_MA($GET_MAP_ARRAY);
			
						
			// Return JSON response
			// ...........................................
			if(empty($DATA_SET) === False)
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS($DATA_SET);
			}
			else
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS('');
			}
			
		}
		Catch(Exception $ERR)
		{		
			PHPVC_LOG::VAR_REPORT_ERROR($ERR, 0);
			if(isset($_SERVER['HTTP_ORIGIN']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_ORIGIN', $_SERVER['HTTP_ORIGIN']);
			}
			if(isset($_SERVER['HTTP_HOST']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_HOST', $_SERVER['HTTP_HOST']);
			}		
			if(isset($_SERVER['HTTP_REFERER']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_REFERER', $_SERVER['HTTP_REFERER']);
			}
			if(isset($_SERVER['REMOTE_ADDR']))
			{
			    PHPVC_LOG::VAR_ERROR('REMOTE_ADDR', $_SERVER['REMOTE_ADDR']);
			}
			
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR->getMessage());
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>